<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_131) on Mon Jul 17 12:51:56 CEST 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Node (APP)</title>
<meta name="date" content="2017-07-17">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Node (APP)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10,"i20":10,"i21":10,"i22":10,"i23":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Node.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../towerwarspp/player/mcts/Mcts.html" title="class in towerwarspp.player.mcts"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../towerwarspp/player/mcts/ScoredNode.html" title="class in towerwarspp.player.mcts"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?towerwarspp/player/mcts/Node.html" target="_top">Frames</a></li>
<li><a href="Node.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">towerwarspp.player.mcts</div>
<h2 title="Class Node" class="title">Class Node</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>towerwarspp.player.mcts.Node</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>class <span class="typeNameLabel">Node</span>
extends java.lang.Object</pre>
<div class="block">Node class that represent Node's in a game tree. Are used as the objects the Monte Carlo tree search algorithm implemented
 in <a href="../../../towerwarspp/player/mcts/Mcts.html" title="class in towerwarspp.player.mcts"><code>Mcts</code></a> operates with.
 A Node holds information about the Move it represents, the color of the player that has this move, the enemy's color,
 the parent of this Node, whether it has a terminal child (representing a terminal game state), a list of explored
 children as well es a list of unexplored children.</div>
<dl>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Robin Hundt</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static double</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#bias">bias</a></span></code>
<div class="block">Bias that is used as a constant in the calculation of the UCB1 in formulae during <a href="../../../towerwarspp/player/mcts/Node.html#bestUCBChild--"><code>bestUCBChild()</code></a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.util.ArrayList&lt;<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#children">children</a></span></code>
<div class="block">Explored (meaning a playout has been done from their represented game state) children of this Node.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static <a href="../../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug">Debug</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#debug">debug</a></span></code>
<div class="block"><a href="../../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug"><code>Debug</code></a> instance that is used to send Debug messages.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#enemy">enemy</a></span></code>
<div class="block">The players enemy.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#expanded">expanded</a></span></code>
<div class="block">A Node is expanded if a simulation has been run for all it's <a href="../../../towerwarspp/player/mcts/Node.html#children"><code>children</code></a> and no <a href="../../../towerwarspp/player/mcts/Node.html#unvisitedChildren"><code>unvisitedChildren</code></a>
 are left.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private double</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#games">games</a></span></code>
<div class="block">Number of games played in the subtree containing this Node.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#move">move</a></span></code>
<div class="block">The move (game state) represented by this Node.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#parent">parent</a></span></code>
<div class="block">The parent Node of this Node.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#player">player</a></span></code>
<div class="block">The player whose possible <a href="../../../towerwarspp/player/mcts/Node.html#move"><code>move</code></a> is saved in the Node.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static java.util.Random</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#random">random</a></span></code>
<div class="block">Static Random instance used generate pseudo random ints.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#terminal">terminal</a></span></code>
<div class="block">A Node is terminal if the Move it represents leads to the end of the game.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#terminalChild">terminalChild</a></span></code>
<div class="block">If a Node has Child that represents a terminal game state, it's reference will be saved here.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.util.ArrayList&lt;<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#unvisitedChildren">unvisitedChildren</a></span></code>
<div class="block">Children of this Node for which no information has been gathered.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private double</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#wins">wins</a></span></code>
<div class="block">Number of wins in the subtree containing this Node.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier</th>
<th class="colLast" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>(package private)</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#Node-towerwarspp.board.Board-double-">Node</a></span>(<a href="../../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board,
    double&nbsp;bias)</code>
<div class="block">Root constructor of the Monte Carlo tree search.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private </code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#Node-towerwarspp.preset.Move-towerwarspp.player.mcts.Node-">Node</a></span>(<a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move,
    <a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;parent)</code>
<div class="block">Private Node constructor that is used to add a new Node to a prior leaf Node.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#backPropagateScore-double-towerwarspp.preset.PlayerColor-">backPropagateScore</a></span>(double&nbsp;score,
                  <a href="../../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;winner)</code>
<div class="block">Method to backpropagate a win score (usually the <a href="../../../towerwarspp/player/mcts/Mcts.html#DEF_SCORE"><code>Mcts.DEF_SCORE</code></a> ) and a winner denoted by his <a href="../../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset"><code>PlayerColor</code></a></div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>(package private) <a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#bestUCBChild--">bestUCBChild</a></span>()</code>
<div class="block">Method to calculate the UCB1 score via <a href="../../../towerwarspp/player/mcts/Node.html#upperConfBound-double-"><code>upperConfBound(double)</code></a> and return the Node that has the highest
 value.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>(package private) int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#childCount--">childCount</a></span>()</code>
<div class="block">Returns the number of explored children.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>(package private) <a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#expand-towerwarspp.board.Board-">expand</a></span>(<a href="../../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board)</code>
<div class="block">Used to expand a Node by selecting one of it's unexplored children from <a href="../../../towerwarspp/player/mcts/Node.html#unvisitedChildren"><code>unvisitedChildren</code></a> and adding it to
 it's <a href="../../../towerwarspp/player/mcts/Node.html#children"><code>children</code></a> list.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>(package private) java.util.ArrayList&lt;<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#fullExpand-towerwarspp.board.Board-">fullExpand</a></span>(<a href="../../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board)</code>
<div class="block">Use this function to fully expand a node.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>(package private) java.util.ArrayList&lt;<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#getChildren--">getChildren</a></span>()</code>
<div class="block">Returns the ArrayList containing this Nodes explored children.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>(package private) <a href="../../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#getEnemy--">getEnemy</a></span>()</code>
<div class="block">Returns the <a href="../../../towerwarspp/player/mcts/Node.html#player"><code>player</code></a>'s enemy.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>(package private) double</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#getGames--">getGames</a></span>()</code>
<div class="block">Games played in this Nodes subtree.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>(package private) <a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#getMove--">getMove</a></span>()</code>
<div class="block">Returns the <a href="../../../towerwarspp/player/mcts/Node.html#move"><code>move</code></a> represented by this Node.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>(package private) <a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#getParent--">getParent</a></span>()</code>
<div class="block">Returns the direct ancestor of this Node.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>(package private) <a href="../../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#getPlayer--">getPlayer</a></span>()</code>
<div class="block">Returns the player associated with the stored <a href="../../../towerwarspp/player/mcts/Node.html#move"><code>move</code></a>.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>(package private) <a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#getTerminalChild--">getTerminalChild</a></span>()</code>
<div class="block">Check first with <a href="../../../towerwarspp/player/mcts/Node.html#hasTerminalChild--"><code>hasTerminalChild()</code></a> if a Node has a terminal Child.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>(package private) double</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#getWeight--">getWeight</a></span>()</code>
<div class="block">Returns the weight (<a href="../../../towerwarspp/player/mcts/Node.html#wins"><code>wins</code></a> / <a href="../../../towerwarspp/player/mcts/Node.html#games"><code>games</code></a> ratio) of this Node.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>(package private) double</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#getWins--">getWins</a></span>()</code>
<div class="block">Wins for this player in this Nodes subtree.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>(package private) boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#hasTerminalChild--">hasTerminalChild</a></span>()</code>
<div class="block">Returns whether this Node has a terminal child (representing a terminal game state).</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>(package private) boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#isExpanded--">isExpanded</a></span>()</code>
<div class="block">Will return true if this Node is fully expanded, meaning for all possible children at least one playout has been done.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>(package private) boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#isTerminal--">isTerminal</a></span>()</code>
<div class="block">Returns the status of <a href="../../../towerwarspp/player/mcts/Node.html#terminal"><code>terminal</code></a></div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>(package private) <a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#maxChild--">maxChild</a></span>()</code>
<div class="block">Method to select the child Node which has the highest weight (win / games ratio) returned by calling <a href="../../../towerwarspp/player/mcts/Node.html#getWeight--"><code>getWeight()</code></a>
 on all of the children this Node.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>(package private) <a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#nthBestUCBChild-int-">nthBestUCBChild</a></span>(int&nbsp;nthHighest)</code>
<div class="block">Returns this Nodes nth highest scored Child after the UCB1 formulae.</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>(package private) <a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#robustChild--">robustChild</a></span>()</code>
<div class="block">Method to select the child Node which has the highest <a href="../../../towerwarspp/player/mcts/Node.html#games"><code>games</code></a> count of all the children this Node has.</div>
</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#setParent-towerwarspp.player.mcts.Node-">setParent</a></span>(<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;parent)</code>
<div class="block">Use to set the parent value of this Node.</div>
</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code>(package private) void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#setTerminalTrue--">setTerminalTrue</a></span>()</code>
<div class="block">Sets both this Nodes <a href="../../../towerwarspp/player/mcts/Node.html#terminal"><code>terminal</code></a> and <a href="../../../towerwarspp/player/mcts/Node.html#expanded"><code>expanded</code></a> status to true and calls <a href="../../../towerwarspp/player/mcts/Node.html#backPropagateScore-double-towerwarspp.preset.PlayerColor-"><code>backPropagateScore(double, PlayerColor)</code></a>
 with arguments <a href="../../../towerwarspp/player/mcts/Mcts.html#DEF_SCORE"><code>Mcts.DEF_SCORE</code></a> and <a href="../../../towerwarspp/player/mcts/Node.html#player"><code>player</code></a> (a terminal Node can only represent a winning move).</div>
</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code>java.lang.String</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#toString--">toString</a></span>()</code>
<div class="block">Returns a string representation of this Node consisting of the <a href="../../../towerwarspp/player/mcts/Node.html#move"><code>move</code></a>, the <a href="../../../towerwarspp/player/mcts/Node.html#player"><code>player</code></a>, whether this
 Node is <a href="../../../towerwarspp/player/mcts/Node.html#expanded"><code>expanded</code></a> and/or <a href="../../../towerwarspp/player/mcts/Node.html#terminal"><code>terminal</code></a>, the number of <a href="../../../towerwarspp/player/mcts/Node.html#wins"><code>wins</code></a> and <a href="../../../towerwarspp/player/mcts/Node.html#games"><code>games</code></a>.</div>
</td>
</tr>
<tr id="i23" class="rowColor">
<td class="colFirst"><code>private double</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../towerwarspp/player/mcts/Node.html#upperConfBound-double-">upperConfBound</a></span>(double&nbsp;bias)</code>
<div class="block">Returns the Upper Confidence Bound 1 (UCB1) value for this Node.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="random">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>random</h4>
<pre>private static final&nbsp;java.util.Random random</pre>
<div class="block">Static Random instance used generate pseudo random ints. No seed is used, since: "This constructor sets the
 seed of the random number generator to a value very likely to be distinct from any other invocation of this constructor."</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="https://docs.oracle.com/javase/8/docs/api/java/util/Random.html#Random--">JavaDoc Random</a></dd>
</dl>
</li>
</ul>
<a name="bias">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>bias</h4>
<pre>private static&nbsp;double bias</pre>
<div class="block">Bias that is used as a constant in the calculation of the UCB1 in formulae during <a href="../../../towerwarspp/player/mcts/Node.html#bestUCBChild--"><code>bestUCBChild()</code></a>.</div>
</li>
</ul>
<a name="debug">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>debug</h4>
<pre>private static&nbsp;<a href="../../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug">Debug</a> debug</pre>
<div class="block"><a href="../../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug"><code>Debug</code></a> instance that is used to send Debug messages.</div>
</li>
</ul>
<a name="player">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>player</h4>
<pre>private final&nbsp;<a href="../../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a> player</pre>
<div class="block">The player whose possible <a href="../../../towerwarspp/player/mcts/Node.html#move"><code>move</code></a> is saved in the Node.</div>
</li>
</ul>
<a name="enemy">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>enemy</h4>
<pre>private final&nbsp;<a href="../../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a> enemy</pre>
<div class="block">The players enemy.</div>
</li>
</ul>
<a name="children">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>children</h4>
<pre>private final&nbsp;java.util.ArrayList&lt;<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&gt; children</pre>
<div class="block">Explored (meaning a playout has been done from their represented game state) children of this Node.</div>
</li>
</ul>
<a name="wins">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>wins</h4>
<pre>private&nbsp;double wins</pre>
<div class="block">Number of wins in the subtree containing this Node.</div>
</li>
</ul>
<a name="games">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>games</h4>
<pre>private&nbsp;double games</pre>
<div class="block">Number of games played in the subtree containing this Node.</div>
</li>
</ul>
<a name="expanded">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>expanded</h4>
<pre>private&nbsp;boolean expanded</pre>
<div class="block">A Node is expanded if a simulation has been run for all it's <a href="../../../towerwarspp/player/mcts/Node.html#children"><code>children</code></a> and no <a href="../../../towerwarspp/player/mcts/Node.html#unvisitedChildren"><code>unvisitedChildren</code></a>
 are left.</div>
</li>
</ul>
<a name="terminal">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>terminal</h4>
<pre>private&nbsp;boolean terminal</pre>
<div class="block">A Node is terminal if the Move it represents leads to the end of the game.</div>
</li>
</ul>
<a name="move">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>move</h4>
<pre>private&nbsp;<a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a> move</pre>
<div class="block">The move (game state) represented by this Node.</div>
</li>
</ul>
<a name="parent">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>parent</h4>
<pre>private&nbsp;<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a> parent</pre>
<div class="block">The parent Node of this Node.</div>
</li>
</ul>
<a name="terminalChild">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>terminalChild</h4>
<pre>private&nbsp;<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a> terminalChild</pre>
<div class="block">If a Node has Child that represents a terminal game state, it's reference will be saved here.</div>
</li>
</ul>
<a name="unvisitedChildren">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>unvisitedChildren</h4>
<pre>private&nbsp;java.util.ArrayList&lt;<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&gt; unvisitedChildren</pre>
<div class="block">Children of this Node for which no information has been gathered.</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="Node-towerwarspp.board.Board-double-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>Node</h4>
<pre>Node(<a href="../../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board,
     double&nbsp;bias)</pre>
<div class="block">Root constructor of the Monte Carlo tree search. Should only be called once per game. Initializes <a href="../../../towerwarspp/player/mcts/Node.html#children"><code>children</code></a>
 of the root with all possible  next game states.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>board</code> - board with initial state to build up tree from</dd>
</dl>
</li>
</ul>
<a name="Node-towerwarspp.preset.Move-towerwarspp.player.mcts.Node-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Node</h4>
<pre>private&nbsp;Node(<a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move,
             <a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;parent)</pre>
<div class="block">Private Node constructor that is used to add a new Node to a prior leaf Node.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>move</code> - move that should be represented by this Node</dd>
<dd><code>parent</code> - direct ancestor of this Node</dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getTerminalChild--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTerminalChild</h4>
<pre><a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;getTerminalChild()</pre>
<div class="block">Check first with <a href="../../../towerwarspp/player/mcts/Node.html#hasTerminalChild--"><code>hasTerminalChild()</code></a> if a Node has a terminal Child.
 If that is the case, this method will return it, otherwise null will be returned.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>terminal Child of this Node</dd>
</dl>
</li>
</ul>
<a name="getWeight--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getWeight</h4>
<pre>double&nbsp;getWeight()</pre>
<div class="block">Returns the weight (<a href="../../../towerwarspp/player/mcts/Node.html#wins"><code>wins</code></a> / <a href="../../../towerwarspp/player/mcts/Node.html#games"><code>games</code></a> ratio) of this Node.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>weight of this Node</dd>
</dl>
</li>
</ul>
<a name="getMove--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMove</h4>
<pre><a href="../../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;getMove()</pre>
<div class="block">Returns the <a href="../../../towerwarspp/player/mcts/Node.html#move"><code>move</code></a> represented by this Node.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>move stored inside this Node</dd>
</dl>
</li>
</ul>
<a name="getPlayer--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPlayer</h4>
<pre><a href="../../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;getPlayer()</pre>
<div class="block">Returns the player associated with the stored <a href="../../../towerwarspp/player/mcts/Node.html#move"><code>move</code></a>.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>player whose <a href="../../../towerwarspp/player/mcts/Node.html#move"><code>move</code></a> is stored</dd>
</dl>
</li>
</ul>
<a name="getEnemy--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getEnemy</h4>
<pre><a href="../../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;getEnemy()</pre>
<div class="block">Returns the <a href="../../../towerwarspp/player/mcts/Node.html#player"><code>player</code></a>'s enemy.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>enemy of <a href="../../../towerwarspp/player/mcts/Node.html#player"><code>player</code></a></dd>
</dl>
</li>
</ul>
<a name="getWins--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getWins</h4>
<pre>double&nbsp;getWins()</pre>
<div class="block">Wins for this player in this Nodes subtree.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><a href="../../../towerwarspp/player/mcts/Node.html#wins"><code>wins</code></a> for <a href="../../../towerwarspp/player/mcts/Node.html#player"><code>player</code></a> in subtree of this Node</dd>
</dl>
</li>
</ul>
<a name="getGames--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getGames</h4>
<pre>double&nbsp;getGames()</pre>
<div class="block">Games played in this Nodes subtree.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><a href="../../../towerwarspp/player/mcts/Node.html#games"><code>games</code></a> played in this subtree</dd>
</dl>
</li>
</ul>
<a name="isExpanded--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isExpanded</h4>
<pre>boolean&nbsp;isExpanded()</pre>
<div class="block">Will return true if this Node is fully expanded, meaning for all possible children at least one playout has been done.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>whether this Node is fully expanded</dd>
</dl>
</li>
</ul>
<a name="getParent--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getParent</h4>
<pre><a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;getParent()</pre>
<div class="block">Returns the direct ancestor of this Node. Null in case of root Node.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the <a href="../../../towerwarspp/player/mcts/Node.html#parent"><code>parent</code></a> Node of this Node</dd>
</dl>
</li>
</ul>
<a name="setParent-towerwarspp.player.mcts.Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setParent</h4>
<pre>void&nbsp;setParent(<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;parent)</pre>
<div class="block">Use to set the parent value of this Node. Is used in <a href="../../../towerwarspp/player/mcts/Mcts.html#freeAncestorMemory-towerwarspp.player.mcts.Node-"><code>Mcts.freeAncestorMemory(Node)</code></a> to set parent references
 to null.</div>
</li>
</ul>
<a name="getChildren--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getChildren</h4>
<pre>java.util.ArrayList&lt;<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&gt;&nbsp;getChildren()</pre>
<div class="block">Returns the ArrayList containing this Nodes explored children.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><a href="../../../towerwarspp/player/mcts/Node.html#children"><code>children</code></a> of this Node</dd>
</dl>
</li>
</ul>
<a name="isTerminal--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isTerminal</h4>
<pre>boolean&nbsp;isTerminal()</pre>
<div class="block">Returns the status of <a href="../../../towerwarspp/player/mcts/Node.html#terminal"><code>terminal</code></a></div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>whether this Node represent a terminal game state</dd>
</dl>
</li>
</ul>
<a name="upperConfBound-double-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>upperConfBound</h4>
<pre>private&nbsp;double&nbsp;upperConfBound(double&nbsp;bias)</pre>
<div class="block">Returns the Upper Confidence Bound 1 (UCB1) value for this Node. The value is calculated like this:
 w / n + c * sqrt( ln(t) / n )
 where:
 w: number of won games for this Node <a href="../../../towerwarspp/player/mcts/Node.html#wins"><code>wins</code></a>
 n: number of games played for this Node <a href="../../../towerwarspp/player/mcts/Node.html#games"><code>games</code></a>
 c: bias parameter that can be set t</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>bias</code> - bias tu use in UCB1 formulae</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>UCB1 score calculated</dd>
</dl>
</li>
</ul>
<a name="toString--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>toString</h4>
<pre>public&nbsp;java.lang.String&nbsp;toString()</pre>
<div class="block">Returns a string representation of this Node consisting of the <a href="../../../towerwarspp/player/mcts/Node.html#move"><code>move</code></a>, the <a href="../../../towerwarspp/player/mcts/Node.html#player"><code>player</code></a>, whether this
 Node is <a href="../../../towerwarspp/player/mcts/Node.html#expanded"><code>expanded</code></a> and/or <a href="../../../towerwarspp/player/mcts/Node.html#terminal"><code>terminal</code></a>, the number of <a href="../../../towerwarspp/player/mcts/Node.html#wins"><code>wins</code></a> and <a href="../../../towerwarspp/player/mcts/Node.html#games"><code>games</code></a>.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code>toString</code>&nbsp;in class&nbsp;<code>java.lang.Object</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>String representation of this Node</dd>
</dl>
</li>
</ul>
<a name="hasTerminalChild--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>hasTerminalChild</h4>
<pre>boolean&nbsp;hasTerminalChild()</pre>
<div class="block">Returns whether this Node has a terminal child (representing a terminal game state).</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>whether this Node has a terminal Child</dd>
</dl>
</li>
</ul>
<a name="childCount--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>childCount</h4>
<pre>int&nbsp;childCount()</pre>
<div class="block">Returns the number of explored children.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>number of children of this Node</dd>
</dl>
</li>
</ul>
<a name="setTerminalTrue--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setTerminalTrue</h4>
<pre>void&nbsp;setTerminalTrue()</pre>
<div class="block">Sets both this Nodes <a href="../../../towerwarspp/player/mcts/Node.html#terminal"><code>terminal</code></a> and <a href="../../../towerwarspp/player/mcts/Node.html#expanded"><code>expanded</code></a> status to true and calls <a href="../../../towerwarspp/player/mcts/Node.html#backPropagateScore-double-towerwarspp.preset.PlayerColor-"><code>backPropagateScore(double, PlayerColor)</code></a>
 with arguments <a href="../../../towerwarspp/player/mcts/Mcts.html#DEF_SCORE"><code>Mcts.DEF_SCORE</code></a> and <a href="../../../towerwarspp/player/mcts/Node.html#player"><code>player</code></a> (a terminal Node can only represent a winning move).</div>
</li>
</ul>
<a name="expand-towerwarspp.board.Board-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>expand</h4>
<pre><a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;expand(<a href="../../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board)</pre>
<div class="block">Used to expand a Node by selecting one of it's unexplored children from <a href="../../../towerwarspp/player/mcts/Node.html#unvisitedChildren"><code>unvisitedChildren</code></a> and adding it to
 it's <a href="../../../towerwarspp/player/mcts/Node.html#children"><code>children</code></a> list.
 Can return null in case there are no next possible game states. In this case <a href="../../../towerwarspp/player/mcts/Node.html#setTerminalTrue--"><code>setTerminalTrue()</code></a> is also
 called on the Node.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>board</code> - board representing a game state from which the current Node should be expanded (board will not be modified)</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the newly created leaf Node</dd>
</dl>
</li>
</ul>
<a name="fullExpand-towerwarspp.board.Board-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>fullExpand</h4>
<pre>java.util.ArrayList&lt;<a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&gt;&nbsp;fullExpand(<a href="../../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a>&nbsp;board)</pre>
<div class="block">Use this function to fully expand a node. Should be used when updating the root
 of the tree. Calling this function will cause <a href="../../../towerwarspp/player/mcts/Node.html#expanded"><code>expanded</code></a> to be set to true.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>board</code> - board representing a game state from which the current Node should be expanded (board will not be modified)</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an ArrayList of Node objects that holds all unvisited Nodes of the current one</dd>
</dl>
</li>
</ul>
<a name="bestUCBChild--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>bestUCBChild</h4>
<pre><a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;bestUCBChild()</pre>
<div class="block">Method to calculate the UCB1 score via <a href="../../../towerwarspp/player/mcts/Node.html#upperConfBound-double-"><code>upperConfBound(double)</code></a> and return the Node that has the highest
 value. Is used to determine the Node in the Selection phase of the MCTS algorithm from which the expansion should
 start.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>child that has the highest UCB1 value</dd>
</dl>
</li>
</ul>
<a name="nthBestUCBChild-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>nthBestUCBChild</h4>
<pre><a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;nthBestUCBChild(int&nbsp;nthHighest)</pre>
<div class="block">Returns this Nodes nth highest scored Child after the UCB1 formulae.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>nthHighest</code> - nth highest child to return</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>child node</dd>
</dl>
</li>
</ul>
<a name="maxChild--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>maxChild</h4>
<pre><a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;maxChild()</pre>
<div class="block">Method to select the child Node which has the highest weight (win / games ratio) returned by calling <a href="../../../towerwarspp/player/mcts/Node.html#getWeight--"><code>getWeight()</code></a>
 on all of the children this Node.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>child Node that has the highest weight</dd>
</dl>
</li>
</ul>
<a name="robustChild--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>robustChild</h4>
<pre><a href="../../../towerwarspp/player/mcts/Node.html" title="class in towerwarspp.player.mcts">Node</a>&nbsp;robustChild()</pre>
<div class="block">Method to select the child Node which has the highest <a href="../../../towerwarspp/player/mcts/Node.html#games"><code>games</code></a> count of all the children this Node has.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>child Node that has the highest game count</dd>
</dl>
</li>
</ul>
<a name="backPropagateScore-double-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>backPropagateScore</h4>
<pre>void&nbsp;backPropagateScore(double&nbsp;score,
                        <a href="../../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;winner)</pre>
<div class="block">Method to backpropagate a win score (usually the <a href="../../../towerwarspp/player/mcts/Mcts.html#DEF_SCORE"><code>Mcts.DEF_SCORE</code></a> ) and a winner denoted by his <a href="../../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset"><code>PlayerColor</code></a></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>score</code> - score that is backpropagated</dd>
<dd><code>winner</code> - Player who won the game</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Node.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../towerwarspp/player/mcts/Mcts.html" title="class in towerwarspp.player.mcts"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../towerwarspp/player/mcts/ScoredNode.html" title="class in towerwarspp.player.mcts"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?towerwarspp/player/mcts/Node.html" target="_top">Frames</a></li>
<li><a href="Node.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
